//
//  mpi_routines.h
//  Daisyworld
//
//  Created by Max Hänze & Christoph Bockhahn on 07.07.12.
//  Copyright (c) 2012 /. All rights reserved.
//

#ifndef Daisyworld_mpi_routines_h
#define Daisyworld_mpi_routines_h
#include <mpi.h>
#include "declarations.h"



int totalNodes;
int rank;
MPI_Status status;
MPI_Datatype worldCellType;
int neighbor1;
int neighbor2;

int cells;
WorldCell* fullWorld;

void initializeParallelEnviroment(int argc,char** argv);
void finalizeParallelEnviroment();

void solveTimestepParallel();
void solveTParallel_FTCS();
void solveAParallel();

void communicateWorld();
int getProcessNeighbor(int i);

void updateFullWorld();
    
#endif
